Index: code/branches/hud3/bin/levels/sample.oxw
===================================================================
--- code/branches/hud3/bin/levels/sample.oxw	(revision 1289)
+++ code/branches/hud3/bin/levels/sample.oxw	(revision 1290)
@@ -11,5 +11,5 @@
 <!--Ambient colourvalue="1,1,1" /-->
 <Skybox src="Orxonox/StarSkyBox" />
-<SpaceShip camera="true" position="0,0,0" scale="10" yawpitchroll="-90,-90,0" mesh="assf3.mesh" maxSpeed="500" maxSideAndBackSpeed="50" maxRotation="1.0" transAcc="200" rotAcc="3.0" transDamp="75" rotDamp="1.0" />
+<SpaceShip camera="true" position="0,0,0" scale="10" yawpitchroll="-90,-90,0" mesh="assff.mesh" maxSpeed="500" maxSideAndBackSpeed="50" maxRotation="1.0" transAcc="200" rotAcc="3.0" transDamp="75" rotDamp="1.0" />
 
 <NPC position="0,100,400" scale="1" mesh="razor.mesh"/>
Index: code/branches/hud3/src/orxonox/console/InGameConsole.cc
===================================================================
--- code/branches/hud3/src/orxonox/console/InGameConsole.cc	(revision 1289)
+++ code/branches/hud3/src/orxonox/console/InGameConsole.cc	(revision 1290)
@@ -43,4 +43,6 @@
 #include "core/InputManager.h"
 #include "GraphicsEngine.h"
+// just for testing purposes
+//#include "SpaceShip.h"
 
 #define LINES 20
@@ -82,4 +84,9 @@
 
     void InGameConsole::execute(){
+/*// just for testing purposes
+	if(consoleOverlayTextAreas[0]->getCaption() == ">")
+		consoleOverlayTextAreas[0]->setCaption(SpaceShip::instance_s->getPosition().x
+			+ "__" + SpaceShip::instance_s->getPosition().y
+			+ "__" + SpaceShip::instance_s->getPosition().z);*/
         newline();
         if (!CommandExecutor::execute(this->ib_->get())){
Index: code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc
===================================================================
--- code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc	(revision 1289)
+++ code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc	(revision 1290)
@@ -101,5 +101,5 @@
   } 
    
-  void RadarOverlayElement::setMainShipPosition(int dirX, dirY, dirZ, ortX, ortY, ortZ){
+  void RadarOverlayElement::setMainShipPosition(int dirX, int dirY, int dirZ, int ortX, int ortY, int ortZ){
     dirX_=dirX;
     dirY_=dirY;
Index: code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc~
===================================================================
--- code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc~	(revision 1289)
+++ code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc~	(revision 1290)
@@ -101,5 +101,5 @@
   } 
    
-  void setMainShipPosition(int dirX, dirY, dirZ, ortX, ortY, ortZ){
+  void RadarOverlayElement::setMainShipPosition(int dirX, dirY, dirZ, ortX, ortY, ortZ){
     dirX_=dirX;
     dirY_=dirY;
Index: code/branches/hud3/src/orxonox/hud/RadarOverlayElement.h
===================================================================
--- code/branches/hud3/src/orxonox/hud/RadarOverlayElement.h	(revision 1289)
+++ code/branches/hud3/src/orxonox/hud/RadarOverlayElement.h	(revision 1290)
@@ -54,5 +54,5 @@
     bool right_;                //checks whether the object is on the right side (since cos is not bijective)
     
-    static int ID = 0;
+    //static int ID = 0;
 
   public:
@@ -63,5 +63,5 @@
 
     void initRadarOverlayElement(Real left, Real top, int dim, Ogre::OverlayContainer* container);
-    void setMainShipPosition(int dirX, dirY, dirZ, ortX, ortY, ortZ);
+    void setMainShipPosition(int dirX, int dirY, int dirZ, int ortX, int ortY, int ortZ);
     
     int newShip(int X, int Y, int Z);
Index: code/branches/hud3/src/orxonox/hud/RadarOverlayElement.h~
===================================================================
--- code/branches/hud3/src/orxonox/hud/RadarOverlayElement.h~	(revision 1289)
+++ code/branches/hud3/src/orxonox/hud/RadarOverlayElement.h~	(revision 1290)
@@ -54,5 +54,5 @@
     bool right_;                //checks whether the object is on the right side (since cos is not bijective)
     
-    static int ID;
+    //static int ID = 0;
 
   public: