Index: code/branches/hud3/src/orxonox/console/InGameConsole.cc
===================================================================
--- code/branches/hud3/src/orxonox/console/InGameConsole.cc	(revision 1291)
+++ code/branches/hud3/src/orxonox/console/InGameConsole.cc	(revision 1292)
@@ -43,6 +43,4 @@
 #include "core/InputManager.h"
 #include "GraphicsEngine.h"
-// just for testing purposes
-//#include "SpaceShip.h"
 
 #define LINES 20
@@ -83,10 +81,5 @@
     }
 
-    void InGameConsole::execute(){
-/*// just for testing purposes
-	if(consoleOverlayTextAreas[0]->getCaption() == ">")
-		consoleOverlayTextAreas[0]->setCaption(SpaceShip::instance_s->getPosition().x
-			+ "__" + SpaceShip::instance_s->getPosition().y
-			+ "__" + SpaceShip::instance_s->getPosition().z);*/
+    void InGameConsole::execute(){	
         newline();
         if (!CommandExecutor::execute(this->ib_->get())){
Index: code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc
===================================================================
--- code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc	(revision 1291)
+++ code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc	(revision 1292)
@@ -24,4 +24,14 @@
 *      ...
 *
+*/
+
+/*	local coordinate system of space ship:
+
+			y
+			+   z
+			|  +
+			| /
+			|/
+	       x +------O
 */
 
Index: code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc~
===================================================================
--- code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc~	(revision 1291)
+++ code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc~	(revision 1292)
@@ -101,5 +101,5 @@
   } 
    
-  void RadarOverlayElement::setMainShipPosition(int dirX, dirY, dirZ, ortX, ortY, ortZ){
+  void RadarOverlayElement::setMainShipPosition(int dirX, int dirY, int dirZ, int ortX, int ortY, int ortZ){
     dirX_=dirX;
     dirY_=dirY;
Index: code/branches/hud3/src/orxonox/hud/RadarOverlayElement.h
===================================================================
--- code/branches/hud3/src/orxonox/hud/RadarOverlayElement.h	(revision 1291)
+++ code/branches/hud3/src/orxonox/hud/RadarOverlayElement.h	(revision 1292)
@@ -25,5 +25,4 @@
 *
 */
-
 
 #ifndef _RADAR_H__
Index: code/branches/hud3/src/orxonox/hud/RadarOverlayElement.h~
===================================================================
--- code/branches/hud3/src/orxonox/hud/RadarOverlayElement.h~	(revision 1291)
+++ code/branches/hud3/src/orxonox/hud/RadarOverlayElement.h~	(revision 1292)
@@ -26,4 +26,13 @@
 */
 
+/*	local coordinate system of space ship:
+
+			y
+			+   z
+			|  +
+			| /
+			|/
+	       x +------O
+*/
 
 #ifndef _RADAR_H__
@@ -63,5 +72,5 @@
 
     void initRadarOverlayElement(Real left, Real top, int dim, Ogre::OverlayContainer* container);
-    void setMainShipPosition(int dirX, dirY, dirZ, ortX, ortY, ortZ);
+    void setMainShipPosition(int dirX, int dirY, int dirZ, int ortX, int ortY, int ortZ);
     
     int newShip(int X, int Y, int Z);
Index: code/branches/hud3/src/orxonox/objects/SpaceShip.cc
===================================================================
--- code/branches/hud3/src/orxonox/objects/SpaceShip.cc	(revision 1291)
+++ code/branches/hud3/src/orxonox/objects/SpaceShip.cc	(revision 1292)
@@ -30,6 +30,4 @@
 #include "SpaceShip.h"
 
-#include <string>
-
 #include <OgreCamera.h>
 #include <OgreRenderWindow.h>
@@ -56,4 +54,5 @@
 {
     ConsoleCommand(SpaceShip, setMaxSpeedTest, AccessLevel::Debug, false);
+    ConsoleCommand(SpaceShip, whereAmI, AccessLevel::User, true);
     ConsoleCommandGeneric(test1, SpaceShip, createExecutor(createFunctor(&SpaceShip::setMaxSpeedTest), "setMaxSpeed", AccessLevel::Debug), false);
     ConsoleCommandGeneric(test2, SpaceShip, createExecutor(createFunctor(&SpaceShip::setMaxSpeedTest), "setMaxBlubber", AccessLevel::Debug), false);
@@ -432,4 +431,10 @@
     }
 
+    std::string SpaceShip::whereAmI() {
+	return getConvertedValue<int, std::string>(SpaceShip::instance_s->getPosition().x)
+	+ "  " + getConvertedValue<int, std::string>(SpaceShip::instance_s->getPosition().y)
+	+ "  " + getConvertedValue<int, std::string>(SpaceShip::instance_s->getPosition().z);
+    }
+
     void SpaceShip::tick(float dt)
     {
Index: code/branches/hud3/src/orxonox/objects/SpaceShip.h
===================================================================
--- code/branches/hud3/src/orxonox/objects/SpaceShip.h	(revision 1291)
+++ code/branches/hud3/src/orxonox/objects/SpaceShip.h	(revision 1292)
@@ -29,7 +29,6 @@
 #ifndef _SpaceShip_H__
 #define _SpaceShip_H__
-
+#include <string>
 #include "OrxonoxPrereqs.h"
-
 #include <OgrePrerequisites.h>
 
@@ -65,4 +64,5 @@
             void getFocus();
 
+	    static std::string whereAmI();
             static void setMaxSpeedTest(float value)
                 { SpaceShip::instance_s->setMaxSpeed(value); }