Index: code/branches/hud3/bin/levels/sample.oxw
===================================================================
--- code/branches/hud3/bin/levels/sample.oxw	(revision 1308)
+++ code/branches/hud3/bin/levels/sample.oxw	(revision 1309)
@@ -14,5 +14,5 @@
 <Skybox src="Orxonox/StarSkyBox" />
 <SpaceShip camera="true" position="0,0,0" scale="10" yawpitchroll="0,0,0" mesh="assff.mesh" maxSpeed="500" maxSideAndBackSpeed="50" maxRotation="1.0" transAcc="200" rotAcc="3.0" transDamp="75" rotDamp="1.0" />
-
+<Model position="1337,0,0" scale="10" mesh="tomato.mesh" yawpitchroll="0,0,0" />
 <NPC position="0,100,400" scale="1" mesh="razor.mesh"/>
 <NPC position="0,100,400" scale="1" mesh="razor.mesh"/>
Index: code/branches/hud3/src/orxonox/CMakeLists.txt
===================================================================
--- code/branches/hud3/src/orxonox/CMakeLists.txt	(revision 1308)
+++ code/branches/hud3/src/orxonox/CMakeLists.txt	(revision 1309)
@@ -7,5 +7,4 @@
   hud/HUD.cc
   hud/BarOverlayElement.cc
-  hud/RadarOverlayElement.cc
   hud/RadarOverlayElement.cc
   particle/ParticleInterface.cc
Index: code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc.mine
===================================================================
--- code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc.mine	(revision 1308)
+++ 	(revision )
@@ -1,82 +1,0 @@
-/*
-*   ORXONOX - the hottest 3D action shooter ever to exist
-*
-*
-*   License notice:
-*
-*   This program is free software; you can redistribute it and/or
-*   modify it under the terms of the GNU General Public License
-*   as published by the Free Software Foundation; either version 2
-*   of the License, or (at your option) any later version.
-*
-*   This program is distributed in the hope that it will be useful,
-*   but WITHOUT ANY WARRANTY; without even the implied warranty of
-*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-*   GNU General Public License for more details.
-*
-*   You should have received a copy of the GNU General Public License
-*   along with this program; if not, write to the Free Software
-*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-*
-*   Author:
-*      Yuning Chai
-*   Co-authors:
-*      ...
-*
-*/
-
-#include <OgreOverlayManager.h>
-#include <OgreOverlayElement.h>
-#include <OgreStringConverter.h>
-#include <math.h>
-#include <string.h>
-
-#include "RadarOverlayElement.h"
-
-
-namespace orxonox
-{
-  using namespace Ogre;
-
-  RadarOverlayElement::RadarOverlayElement(const String& name):Ogre::PanelOverlayElement(name){}
-
-  RadarOverlayElement::~RadarOverlayElement(){}
-
-  void RadarOverlayElement::initialise(){
-    PanelOverlayElement::initialise();
-  }
-  
-  void RadarOverlayElement::initRadarOverlayElement(){
-    int dirX, dirY, dirZ;      //flying direction
-    int ortX, ortY, ortZ;      //orthogonal direction
-    int dX, dY, dZ;            //distance between main ship and the object
-    int vecX, vecY, vecZ;      //vector product dir X ort
-    double alpha;              //defines the radius in the radar
-    double beta;               //defines the angle in the radar
-    bool right;                //checks whether the object is on the right side (since cos is not bijective)
-    
-    dirX = 1;
-    dirY = 0;
-    dirZ = 0;
-    
-    ortX = 0;
-    ortY = 0;
-    ortZ = 1;
-    
-    dX = 2;
-    dY = 0;
-    dZ = 0;
-    
-    alpha = acos((dirX*dX+dirY*dY+dirZ*dZ)/(sqrt(pow(dX,2)+pow(dY,2)+pow(dZ,2))+sqrt(pow(dirX,2)+pow(dirY,2)+pow(dirZ,2))));
-    beta = acos((ortX*X+ortY*dY+ortZ*dZ)/(sqrt(pow(dX,2)+pow(dY,2)+pow(dZ,2))+sqrt(pow(ortX,2)+pow(ortY,2)+pow(ortZ,2))));
-    vecX = dirY*ortZ - dirZ*ortY;
-    vecY = dirZ*ortX - dirX*ortZ;
-    vecZ = dirX*ortY - dirY*ortX;
-    
-    if((vecX*dX+vecY*dY+vecZ*dZ)>0){right=true;}
-    else right=false;
-
-
-}
-
-
Index: code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc.r1099
===================================================================
--- code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc.r1099	(revision 1308)
+++ 	(revision )
@@ -1,77 +1,0 @@
-/*
-*   ORXONOX - the hottest 3D action shooter ever to exist
-*
-*
-*   License notice:
-*
-*   This program is free software; you can redistribute it and/or
-*   modify it under the terms of the GNU General Public License
-*   as published by the Free Software Foundation; either version 2
-*   of the License, or (at your option) any later version.
-*
-*   This program is distributed in the hope that it will be useful,
-*   but WITHOUT ANY WARRANTY; without even the implied warranty of
-*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-*   GNU General Public License for more details.
-*
-*   You should have received a copy of the GNU General Public License
-*   along with this program; if not, write to the Free Software
-*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-*
-*   Author:
-*      Yuning Chai
-*   Co-authors:
-*      ...
-*
-*/
-
-#include <OgreOverlayManager.h>
-#include <OgreOverlayElement.h>
-#include <OgreTextAreaOverlayElement.h>
-#include <OgreStringConverter.h>
-#include <string.h>
-
-#include "Radar.h"
-
-
-namespace orxonox
-{
-  using namespace Ogre;
-
-  RadarObject::RadarObject(int name, Ogre::Real x, Ogre::Real y, Ogre::Real z){
-    name_ = name;
-    x = x_;
-    y = y_;
-    z = z_;
-  }
-
-  RadarObject::~RadarObject(void){}
-    
-  void RadarObject::reset(Ogre::Real x, Ogre::Real y, Ogre::Real z){
-    x = x_;
-    y = y_;
-    z = z_;
-  }
-
-
-  Radar::Radar(){
-    number = 0;
-    
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-
-}
-
-
Index: code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc.r1248
===================================================================
--- code/branches/hud3/src/orxonox/hud/RadarOverlayElement.cc.r1248	(revision 1308)
+++ 	(revision )
@@ -1,82 +1,0 @@
-/*
-*   ORXONOX - the hottest 3D action shooter ever to exist
-*
-*
-*   License notice:
-*
-*   This program is free software; you can redistribute it and/or
-*   modify it under the terms of the GNU General Public License
-*   as published by the Free Software Foundation; either version 2
-*   of the License, or (at your option) any later version.
-*
-*   This program is distributed in the hope that it will be useful,
-*   but WITHOUT ANY WARRANTY; without even the implied warranty of
-*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-*   GNU General Public License for more details.
-*
-*   You should have received a copy of the GNU General Public License
-*   along with this program; if not, write to the Free Software
-*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
-*
-*   Author:
-*      Yuning Chai
-*   Co-authors:
-*      ...
-*
-*/
-
-#include <OgreOverlayManager.h>
-#include <OgreOverlayElement.h>
-#include <OgreStringConverter.h>
-#include <math.h>
-#include <string.h>
-
-#include "RadarOverlayElement.h"
-
-
-namespace orxonox
-{
-  using namespace Ogre;
-
-  RadarOverlayElement::RadarOverlayElement(const String& name):Ogre::PanelOverlayElement(name){}
-
-  RadarOverlayElement::~RadarOverlayElement(){}
-
-  void RadarOverlayElement::initialise(){
-    PanelOverlayElement::initialise();
-  }
-  
-  void RadarOverlayElement::initRadarOverlayElement(){
-    int dirX, dirY, dirZ;      //flying direction
-    int ortX, ortY, ortZ;      //orthogonal direction
-    int dX, dY, dZ;            //distance between main ship and the object
-    int vecX, vecY, vecZ;      //vector product dir X ort
-    double alpha;              //defines the radius in the radar
-    double beta;               //defines the angle in the radar
-    bool right;                //checks whether the object is on the right side (since cos is not bijective)
-    
-    dirX = 1;
-    dirY = 0;
-    dirZ = 0;
-    
-    ortX = 0;
-    ortY = 0;
-    ortZ = 1;
-    
-    dX = 2;
-    dY = 0;
-    dZ = 0;
-    
-    alpha = acos(((double)(dirX*dX+dirY*dY+dirZ*dZ))/(sqrt((double)(pow(dX,2)+pow(dY,2)+pow(dZ,2)))+sqrt((double)(pow(dirX,2)+pow(dirY,2)+pow(dirZ,2)))));
-    beta = acos(((double)(ortX*dX+ortY*dY+ortZ*dZ))/(sqrt((double)(pow(dX,2)+pow(dY,2)+pow(dZ,2)))+sqrt((double)(pow(ortX,2)+pow(ortY,2)+pow(ortZ,2)))));
-    vecX = dirY*ortZ - dirZ*ortY;
-    vecY = dirZ*ortX - dirX*ortZ;
-    vecZ = dirX*ortY - dirY*ortX;
-    
-    if((vecX*dX+vecY*dY+vecZ*dZ)>0){right=true;}
-    else right=false;
-
-
-}
-
-